import datetime
import time
from bs4.element import Tag
from bs4 import BeautifulSoup
from selenium import webdriver
from fake_useragent import UserAgent

current_time = datetime.datetime.now()
time_two_hours_later = current_time + datetime.timedelta(hours=2)
timestamp_two_hours_later = int(time_two_hours_later.timestamp())

cookie = {
    "domain": ".drikpanchang.com",
    "expiry": timestamp_two_hours_later,
    "httpOnly": False,
    "name": "dkpgridview",
    "path": "/",
    "sameSite": "Lax",
    "secure": True,
    "value": "horizontal",
}


ua = UserAgent()
options = webdriver.ChromeOptions()
options.add_argument(f"user-agent={ua.random}")  # type:ignore
driver = webdriver.Chrome(options=options)
driver.get("https://www.drikpanchang.com/nepali/calendar/nepali-patro.html")
driver.add_cookie(cookie)  # type:ignore
time.sleep(20)

def get_url(year: int, month: str):
    return f"https://www.drikpanchang.com/nepali/calendar/nepali-patro.html?solar-date=01/{month}/{year}"


def get_months(year: int):
    months: list[int] = []

    for month in [
        "01",
        "02",
        "03",
        "04",
        "05",
        "06",
        "07",
        "08",
        "09",
        "10",
        "11",
        "12",
    ]:
        url = get_url(year, month)
        while True:
            driver.get(url)
            time.sleep(1)

            soup = BeautifulSoup(driver.page_source, "html.parser")
            calendar = soup.find("div", {"class": "dpMonthGrid"})

            if isinstance(calendar, Tag):
                rows = calendar.find_all("div", {"class": "dpMonthGridRow"})
                last_row = rows[-1]

                month_divs: list[Tag] = []
                for div in last_row.find_all("div", attrs={"class": True}):
                    div_class = div["class"]
                    if "dpMonthGridCell" in div_class and "dpInert" not in div_class:
                        month_divs.append(div)

                month_div = month_divs[-1]

                month_count = int(
                    month_div.find("span", {"class": "dpBigDate"}).contents[0]  # type:ignore
                )
                months.append(month_count)
                break

    return months


for year in range(2242, 2300):
    months = get_months(year)
    months.insert(0, sum(months))
    print(f"{year}: {months},")
